<!-- 设备台账信息详情 设备流转日志 -->
<script name="StandardBookEquipmentFlowLog" lang="ts" setup>
import type { Ref } from 'vue'
import { onMounted, ref } from 'vue'
import dayjs from 'dayjs'
import { ElLoading, ElMessage } from 'element-plus'
import type { IEquipmentFlowLog } from '../book-interface'
import { getDictByCode } from '@/api/system/dict'
import { getEquipmentFlowLog } from '@/api/equipment/info/book'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import useUserStore from '@/store/modules/user'
import type { deptType, dictType } from '@/global'
const props = defineProps({
  equipmentNo: { // 设备编号
    type: String,
    require: true,
  },
})
// 查询条件
const listQuery = ref({
  equipmentNo: '', // 设备编号
  offset: 1,
  limit: 20,
})
const equipmentNo = ref('') // 设备编号
const loadingTable = ref(false) // 表格loading
const total = ref(0) // 表格数据条数
const user = useUserStore() // 用户信息
const list = ref<IEquipmentFlowLog[]>([]) // 表格数据
const columns = ref<TableColumn[]>([ // 表头
  { text: '使用部门', value: 'deptName', align: 'center' },
  { text: '负责人', value: 'directorName', align: 'center' },
  { text: '记录日期', value: 'createTime', align: 'center', width: '120' },
])

// -----------------------------------------方法--------------------------------------------------
// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  listQuery.value.equipmentNo = equipmentNo.value // 设备编号
  getEquipmentFlowLog(listQuery.value).then((response) => {
    list.value = response.data.rows.map((item: { createTime: string }) => {
      return {
        ...item,
        createTime: item.createTime ? dayjs(item.createTime).format('YYYY-MM-DD') : item.createTime,
      }
    })
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  }).catch(() => {
    loadingTable.value = false
  })
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}
// -------------------------------------------钩子------------------------------------------------
watch(() => props.equipmentNo, (newValue) => {
  console.log('监听到props.equipmentNo', newValue)
  equipmentNo.value = newValue!
}, { immediate: true })
onMounted(async () => {
  fetchData()
})
</script>

<template>
  <detail-block title="设备流转日志">
    <normal-table
      :data="list" :total="total" :columns="columns"
      :query="{ limit: listQuery.limit, offset: listQuery.offset }"
      :list-loading="loadingTable"
      @change="changePage"
    >
      <template #preColumns>
        <el-table-column label="序号" width="55" align="center">
          <template #default="scope">
            {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
          </template>
        </el-table-column>
      </template>
    </normal-table>
  </detail-block>
</template>
